# coding:utf-8
#
'''
                         ## para i variando de 1 a n-1,
                         ## mantém a parte inicial seq[0...i] ordenada crescent.
                         ## Supondo que a parte seq[0..i-1] esteja ordenada cresc.
                         ## procuramos onde o item seq[i] deve ser encaixado.
   ordena3_insercao.py   ## Nesta versao, este item vai trocando de posição
                         ## com o seu vizinho do lado esquerdo, caso ele seja menor,
                         ## até que se chegue numa posição em que ele não deve mais 
                         ## mudar de posição.

   Dados um inteiro positivo n e uma sequência de n números inteiros,
   imprimi-los em ordem crescente.
'''
#-----------------------------------------------------------------------

def main():
    # n = int(input("Digite o número de elementos da sequência: "))    
    # seq = []  
    # for i in range(n):
    #    num = int(input("Digite um inteiro da sequência: "))
    #    seq.append(num)    
    #------------------------------------------------------
    ## Vamos considerar a sequencia seq abaixo (sem fazer leitura, ou gerar aleatoriamente):
    
    seq = [5, 20, 3, 2, 14, 1, 7, 9, 15, 4]
    n = 10 
    print("sequencia dada  =", seq)

    ordenacao_por_insercao(seq)  ## chamada da funcao que faz a ordenacao
    
    print("\nSequência de inteiros em ordem crescente:")
    for num in seq:
        print(num, end='  ')   
    print()

#------------------------------------------------------------------------
def troca(x, i, j):
    '''
    dada uma lista x, permute os valores em x[i] e x[j]
    '''
    x[i], x[j] = x[j], x[i]

   #--------------------------------------

def ordenacao_por_insercao(lista):
    ''' (list) -> NoneType
       
    Recebe uma lista com todos os valores de mesmo tipo.
    Rearranja os elementos de lista em ordem crescente; ou seja,
    de modo que satisfaçam: lista[0] <= lista[1] <= ...
    '''
    
    print()
    print("--------lista =", lista)   
    n = len(lista)
    for i in range(1, n):
            #### 'Insere', ou seja, posiciona lista[i] em lista[0...i] 
            ####  de modo que lista[0...i] fique ordenado crescentemente.
        j = i 
        while (j > 0 and lista[j] < lista[j-1]):
            troca(lista, j, j-1)
            print("i =%2d - lista = %s" %(i, lista)) # apenas para acompanhar cada passo
            j = j-1    
        #print("i =%2d - lista = %s" %(i, lista)) # apenas para acompanhar cada passo
        
#------------------------------------------------------------------------
main()
